
int ledPin = 11;                 // LED connected to pin 11
int analogPin = 0;
int analogue_val = 0;

int time_measurement_interval = 100; 

int start_time_ms = 0;
int current_time_ms = 0;

int min_value = 0;
int max_value = 0;
int min_max_difference = 0;

void setup()
{
  //activates serial out 
  Serial.begin(115200);
}

void loop()
{
  analogue_val = analogRead(analogPin);   // read the input pin
    
  // calculate the min/max values in every loop
  if (analogue_val < min_value)
  {
    
  	min_value = analogue_val;
  }
  else if (analogue_val > max_value)
  { 
  	max_value = analogue_val;
  }

  //Get current time from Arduino clock
  current_time_ms = millis();
    
  // this is the timing part - getting measurements every so often
  if (current_time_ms > (start_time_ms + time_measurement_interval))
  {
    //the difference of min and max voltage values is used to quantify the voltage fluctuation
    min_max_difference = max_value-min_value;
    
    //writing some explanations over the serial connection
    Serial.print("min = ");
    Serial.print(min_value);
    Serial.print("   max ");
    Serial.print(max_value); 
    Serial.print("    difference = ");
    Serial.print(min_max_difference);
    Serial.print("\n");
    // applying a noise treshold to the difference value
    if(min_max_difference<8) min_max_difference=0; else min_max_difference=min_max_difference-7;
    // translates the difference value to intensity of LED
    analogWrite(ledPin, min_max_difference*8);
    // resets the starttime, so we have an appropriate value
    // for the next measurement
    start_time_ms = millis();
	
    // reset values
    min_value = analogue_val;
    max_value = analogue_val;
  }
  // if arduino clock has reset to zero, then reset everything
  else if (current_time_ms < start_time_ms) //for clocks resetting to zero
  {
	Serial.println("the arduino clock has reset");
	// saves an appropriate value for the next round
	start_time_ms = millis();
	  
	// reset values
  	min_value = analogue_val;
	max_value = analogue_val;
  }
}
